/* UFO Extender - Mod for X-COM
 * See <http://www.ufopaedia.org/index.php?title=User:Seb76> for more details.
 * Copyright (C) 2008 Seb76
 *
 * This file is part of UFO Extender.

 * UFO Extender is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * UFO Extender is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with UFO Extender.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "stdafx.h"
#include "patcher.h"
#include "patches.h"
#include "xcom.h"

#include "roswell.h"
#include "smoke.h"
#include "hacks.h"
#include "base.h"
#include "music.h"
#include "heavylaser.h"
#include "stun.h"

#define HEAVY_LASER_MOD


/*
 * TODO:
 *  -ammo weight bug in inventory
 *  -keyboard shortcuts
 *  -base defense reset retaliation flag
 *  -psi attacks target random soldier
 *  -mind controlled civilians become hostile
 *  -mind controlled soldiers at the end become MIA
 *  -more realistic grenade fuse
 *  -faster base defense sequence
 *  -link to full stats in inventory
 *
 *  -change soldiers' positions in crafts 
 *  -open/close doors  la xcom2
 *  -80 items limit??
 *
 */


/*
 * Make visible the presence of the loader
 */
void ShowMod()
{
	DrawString("All your base are belong to us",0x8B,52,88,1);
	((void (*)(int))(0x42F680))(1);
}


/*
 * Fix the garbled screen problem by taking into account the surface's pitch
 */
void FixPitch(char *src)
{
	if(char *dst=DD_SurfaceLock())
	{
		IDirectDrawSurface *pSurface=*(IDirectDrawSurface **)0x478604;
		DDSURFACEDESC SurfaceDesc;
		SurfaceDesc.dwSize=sizeof(SurfaceDesc);

		pSurface->GetSurfaceDesc(&SurfaceDesc);
		int pitch=SurfaceDesc.lPitch;

		for(int i=0;i<200;i++)
		{
			memcpy(dst,src,320);
			dst+=pitch;
			src+=320;
		}

		DD_SurfaceUnlock();
		DD_SurfaceFlip();
	}
}

/*
 * Equipment screen mod
 */
void ShowEncumberance(void)
{
	int encumberance=GetUnitEncumberance(*unitIdx);
	unsigned char strength=(*currentUnit_pUnitRef)->Strength;
	unsigned char accuracy=(*currentUnit_pUnitRef)->Firing_Acc;
	unsigned char reaction=(*currentUnit_pUnitRef)->React_Current;
	unsigned char psi_strength=(*currentUnit_pUnitRef)->Psi_Strength;
	unsigned char psi_skill=(*currentUnit_pUnitRef)->Psi_Skill;

	static char weight_str[16];
	static char accuracy_str[16];
	static char reaction_str[16];
	static char psi_strength_str[16];
	static char psi_skill_str[16];
	static int init=0;
	if(init==0) {
		init=1;
		INI_READ_STRING("Equipment Screen","Weight","Weight>",weight_str,16);
		INI_READ_STRING("Equipment Screen","Accuracy","Accur>",accuracy_str,16);
		INI_READ_STRING("Equipment Screen","Reaction","React>",reaction_str,16);
		INI_READ_STRING("Equipment Screen","Psi Strength","P.Str>",psi_skill_str,16);
		INI_READ_STRING("Equipment Screen","Psi Skill","P.Skill>",psi_strength_str,16);
	}

	//Draw weight stats
	DrawString(weight_str,0x40,24,245,1);
	DrawNumber(encumberance,0x10,*carretPosition,1);
	DrawSmallLetter('/',0x40,*carretPosition);
	DrawNumber(strength,0x30,*carretPosition,1);

	//Only draw other stats during equiping phase
	if(*tactical_mainState != 2)
	{
		DrawString(accuracy_str,0x40,32,245,1);
		DrawNumber(accuracy,0x10,*carretPosition,1);

		DrawString(reaction_str,0x40,40,245,1);
		DrawNumber(reaction,0x10,*carretPosition,1);

		//Only draw psi stats when unit has been in psi-lab
		if(psi_skill)
		{
			DrawString(psi_skill_str,0x40,48,245,1);
			DrawNumber(psi_skill,0x10,*carretPosition,1);

			DrawString(psi_strength_str,0x40,56,245,1);
			DrawNumber(psi_strength,0x10,*carretPosition,1);
		}
	}
}

/*
 * The procedure that randomizes the shots trajectory is bugged when shooting vertically.
 * We disable it when it is the case to fix the blaster bomb bug.
 */
void FixedAccuracyCompensation()
{
	short x1=*(short *)0x4783F8;
	short y1=*(short *)0x4783FA;
	short x2=*(short *)0x478400;
	short y2=*(short *)0x478402;

	if( x1 == x2 && y1 == y2 ) //vertical shot
		return;

	AdjustShotWithAccuracy();
}

/*
 * Called when scrolling in tactical mode. This reduces the scroll speed
 */
void TimeFix(int eax)
{
	DWORD tac_time,delta;
	tac_time=timeGetTime();
	((void (*)(int))(0x428970))(eax);
	delta=timeGetTime()-tac_time;

	if(delta<20)
	{
		Sleep(20-delta);
	}
}



/*
 * TU reservation mode
 * We save the mode when ending turn and restore it
 * before the next human turn
 */
static short savedReservedMode=0;
void SaveReserveMode()
{
	savedReservedMode=*tac_currentTUReserveMode;
}
void RestoreReserveMode()
{
	*tac_currentTUReserveMode=savedReservedMode;
}

/*
 * Detect successful ground assault missions and trigger reaction from alien
 */
void RetaliationAfterGroundAssault(void *dstbuf, int filename)
{
	char victoryStatus;
	LoadFile(dstbuf,filename);
	victoryStatus=tac_misdata[0x4e];

	if(victoryStatus == 1) //mission successful
	{
		char locIdx=tac_misdata[0x4c];
		if( ((*locationList+20*locIdx))[0] == 1 ) //Landed UFO have type 1 here, not 6!!!
		{
			char ufoIdx=(*locationList+20*locIdx)[1];
			char craftIdx=tac_misdata[0x4d];
			void *attacker=(void *)(*craftList+104*craftIdx);
			void *ufo=(void *)(*craftList+104*ufoIdx);
			AlienTakeActionAfterShootDown(ufo,attacker);
		}
	}
}

/*
 * Wreck analysis
 * Each navigation module can provide zone and/or mission data
 * The probability may need some tweaking
 */
void WreckAnalysis(int number, int color, __int16 ypos, __int16 xpos, int useSmallFonts)
{
	DrawNumber2(number, color, ypos, xpos, useSmallFonts);

	int recoveredNavigation=tac_misdata[2];
	int i;
	int discoverZone=0;
	int discoverMission=0;
	char buf[256];
	char format[256];

	char victoryStatus=tac_misdata[0x4e];
	char missionDescriptor=tac_misdata[0x14];

	//Only work on successful ground missions
	if(victoryStatus != 1 && missionDescriptor != 0 )
		return;

	//"analyze" each navigation module
	for(i=0;i<recoveredNavigation;i++)
	{
		if(GetRandom_0_n(100)<20-*difficultyLevel*2)
		{
			discoverZone=1;
		}
		if(GetRandom_0_n(100)<20-*difficultyLevel*2)
		{
			discoverMission=1;
		}
	}


	char locIdx=tac_misdata[0x4c];
	char ufoIdx=(*locationList+20*locIdx)[1];
	int type=(*craftList+104*ufoIdx)[28];
	int zone=(*craftList+104*ufoIdx)[30];
	int race=(*craftList+104*ufoIdx)[36];
	
	char *missionName=StringTable_geoscape[558+type];
	char *zoneName=StringTable_geoscape[543+zone];
	char *raceName=StringTable_geoscape[466+race];


	if(discoverMission&&discoverZone)
	{
		INI_READ_STRING("Wreck Analysis","Both Discovered","Ship investigation revealed that the %s UFO was on an %s mission in %s",format,256);
		sprintf(buf,format,raceName,missionName,zoneName);
	}
	else if(discoverMission)
	{
		INI_READ_STRING("Wreck Analysis","Mission Discovered","Inspection showed that the %s UFO was on an %s mission",format,256);
		sprintf(buf,format,raceName,missionName);
	}
	else if(discoverZone)
	{
		INI_READ_STRING("Wreck Analysis","Zone Discovered","Intel found out that the %s UFO was raiding %s",format,256);
		sprintf(buf,format,raceName,zoneName);
	}
	else
	{
		return;
	}

	*DrawText_rightBorder=320-16;
	DrawString(buf,0x8b,ypos+16,16,1);
}


/*
 * Draw the rank icon in the equipment screen
 */
void DrawRank(char *str, int color, __int16 ypos, __int16 xpos, int smallFont)
{
	DrawString(str,color,ypos,xpos+32,smallFont);
	char **unitref=(char **)0x4783C4;
	if((*unitref)[0]>2) //aliens have no rank icons
		return;

	int rank=(*unitref)[0x2a];
	short oldGFX=*currentGFXPackage;

	LoadGFXRessources(1);
	
	char *icon=*smokePCKRessources+*(*smokeTabRessources+20+rank);
	DrawRankIcon((int)*BackBuffer,(int)icon,32);
#if 0
	if(*mouse_num_click1&&*mouse_xpos<32&&*mouse_ypos<32)
	{
		short saved_state=*tactical_mainState;
		char fb[320*200];
		memcpy(fb,*BackBuffer,320*200);
		*mouse_num_click1=0;
		LoadGFXRessources(3);
//		ShowSoldierStats(*currentUnit_pUnitPos);
		ShowSoldierStats(*(char **)0x4783C0);

		/*
		((void (*)(int))(0x42F680))(1);
		((void (*)())(0x412C80))();

		while(!*mouse_buttons);
		{
			((void (*)())(0x42FDD0))();
		}
		
		*tactical_mainState=saved_state;
		memcpy(*BackBuffer,fb,320*200);
*/
	}
#endif
	LoadGFXRessources(oldGFX);
}


/*
 * Trigger reaction fire when units turn
 * The two functions are called when the unit's orientation change
 */
void ReactionFire1()
{
	((void (*)())(0x42DD50))();
	PerformReactionFire();
}

void ReactionFire2(int xpos, int ypos, int zpos, __int16 orientation, __int16 distance)
{
	ComputeVisibleAliens(xpos, ypos, zpos, orientation, distance);
	PerformReactionFire();
}


/*
 * Repopulate the activated proximity grenade list during each loop of the battlescape.
 * This is crude but effective. As an added bonus, it reduces the speed of the game ;-)
 * Better solution would be to update it only during unit movement.
 */
void FixProximityMines()
{
	for(int i=0;i<20;i++)
		tac_prox_mine_list[i].active=0;

	int mine_idx=0;

	for(int i=0;i<170;i++)
	{
		char *pObpos=&pObpos_dat[i*16];
		if(pObpos[0]==0x15&&pObpos[8]==1&&pObpos[4]==-1) //armed prox mine on the ground
		{
			tac_prox_mine_list[mine_idx].active=1;
			tac_prox_mine_list[mine_idx].pObpos=pObpos;
			mine_idx++;
			if(mine_idx==20)
				break;
		}
	}

	ActAccordingToTacticalState();
}

/*
 * Explosions give experience to the "current unit". For proxmines, developers forget to change it before generating
 * the explosion and the experience does not go to the correct unit.
 */
void FixProximityMinesExperience(int xpos, int ypos, __int16 zpos, int strength, int a, int b, __int16 c)
{
	unsigned char *pObpos;
	unsigned char thrower_idx;
	
	//save the current unit
	short saved_idx=*currentUnit_idx;

	__asm 
	{
		mov eax,[esi+2];
		mov pObpos,eax;
	}

	//set current unit to the thrower
	thrower_idx=pObpos[9];
	SetCurrentUnit(thrower_idx);
	
	//boom!
	GenerateExplosion(xpos, ypos, zpos, strength, a, b, c);

	//restore the current unit
	SetCurrentUnit(saved_idx);
}

/*
 * Helper to draw dialog boxes
 */
void DrawDialog(char *line1, char *line2)
{
	//Draw box
	((void (*)(int,int,int,int,int))(0x41E3F0))(0x30,0x32,0x58,0xDC,1);


	*DrawText_leftBorder=0xA0;
	DrawString(line1,0x10,0x40,0x50,0);
	*DrawText_leftBorder=0xA0;
	DrawString(line2,0x10,0x50,0x50,0);
	*ui_numButtons=0;

	//"OK" button
	CreateButton(0x70,0x64,0x12,0x78,0x10,StringTable_battlescape[77]);

	((void (*)(int))(0x42F680))(1);

	WaitTillMouseButtonsAreReleased();
	while(!CheckForClickedButton());
}

/*
 * Elerium ships have a constant consumption rate of 1 (for standard ship, consumption is based on ship speed).
 * This rate is used at 2 places: to know when the ship has burnt half its fuel, and to determine how much distance
 * it can still fly. The second part is buggy however and uses the standard ship formula so we end up with a fly distance
 * of 0 and the ship returns immedialty. This should fix the issue.
 */
__declspec(naked) void EleriumShipFix()
{
	__asm
	{
		mov eax,edi
		cdq
		
		cmp bl,0
		jz std_fuel
		cmp bl,3
		jz std_fuel
		ret
std_fuel:
		idiv ecx
		ret
	}
}

/*
 * Call the KillUnit function when an unconscious corpse is destroyed.
 * The KillUnit function generates a body and we don't want that. To prevent
 * it, we find which obpos will be used for the body (gotten with GetFreeObPosRef)
 * and clear the object after we called the function. Since big units can use
 * 4 objects, we check the 4 next obpos.
 */
void ObjectDestroyed(unsigned char *pObpos)
{
	int flags=pObpos[12];
	if(flags&8) //unconscious corpse
	{
		int obtype=pObpos[0];
		if(obtype>=58&&obtype<=77) //big units: get out
			return;

		short corpse[4];
		int unitidx=pObpos[8];
		char *unitpos=&(unitpos_dat)[14*unitidx];
		char *unitref=*(char **)&(unitpos[4]);

		//save the next 4 free obpos
		for(int i=0;i<4;i++)
		{
			corpse[i]=GetFreeObPosRef();
		}

		Tactical_KillUnit(unitidx);

		//clear the obpos since they contain body objects
		for(int i=0;i<4;i++)
		{
			if(corpse[i]!=-1)
				pObpos_dat[16*corpse[i]]=0xff;
		}

		DrawDialog(&unitref[0x56],"got blasted");
	}
}

//Call the ObjectDestroyed function instead of just destroying the object by clearing its objType field
__declspec(naked) void CheckDestroyObject()
{
	__asm
	{
		jbe skip
		pusha
			
		sub esi,6
		push esi
		call ObjectDestroyed
		add esp,4

		popa
		mov     [esi-6], bl
skip:
		ret
	}
}



//// shortcuts ////

#define SHORTCUT_ENDTURN 1
#define SHORTCUT_MULTILEVELVIEW 2
#define SHORTCUT_SHOWMAP 3
#define SHORTCUT_CENTER 4
#define SHORTCUT_INVENTORY 5
#define SHORTCUT_KNEEL 6
#define SHORTCUT_NEXT 7
#define SHORTCUT_NEXT_SKIP 8
#define SHORTCUT_VIEWUP 9
#define SHORTCUT_VIEWDOWN 10
#define SHORTCUT_GOUP 11
#define SHORTCUT_GODOWN 12
#define SHORTCUT_LEFTMENU 13
#define SHORTCUT_RIGHTMENU 14
#define SHORTCUT_STATS 15
#define SHORTCUT_OPTIONS 16
#define SHORTCUT_LIFTOFF 17
#define SHORTCUT_RESERVENONE 18
#define SHORTCUT_RESERVESNAP 19
#define SHORTCUT_RESERVEAUTO 20
#define SHORTCUT_RESERVEAIMED 21

static short shortcut=-1;
void CheckShortcut()
{
	if(shortcut!=-1)
	{
		StatusBarClicked(shortcut);
		shortcut=-1;
	}
	else
	{
		CheckIfClickedOnStatusBar();
	}
}

static int keyPressed=0;
static unsigned char key;

int CheckKeyboardState()
{
	return keyPressed?1:0;
}
int GetPressedKey()
{
	keyPressed=0;
	return key;
}
LRESULT __stdcall MyDefWindowProcA(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	if(Msg==WM_CHAR)
	{
		*HasKeyBeenPressed=1;
		key=wParam;
		keyPressed=1;
		//if(*IsTacticalMode==1&&*tactical_mainState==1)
		{
			switch(key)
			{
			case '1':
				shortcut=SHORTCUT_RESERVENONE;
				break;
			case '2':
				shortcut=SHORTCUT_RESERVESNAP;
				break;
			case '4':
				exit(0);
				break;
			case '3':
				key=13;
				break;
			}
		}
	}
	else if(Msg==WM_KEYDOWN)
	{

	}
	return DefWindowProcA(hWnd, Msg, wParam, lParam);
}

const char *GetObjectDescription(const char *defaultDescription)
{
	unsigned char *pObpos=(unsigned char *)&pObpos_dat[*inventory_draggedItem_obPosIdx*16];
	static int init;
	static char primed[32];
	if(init==0) {
		init=1;
		INI_READ_STRING("Equipment Screen","Primed","primed",primed,16);
	}

	switch(*inventory_draggedItem_objectType)
	{
	case 0x13://grenade
	case 0x14://smoke
	case 0x16://HE
	case 0x2c://alien grenade
	case 0x15://proximity
		if(pObpos[8]!=0)//quantity1
		{
			static char str[128];
			sprintf(str,"%s (%s)",defaultDescription,primed);
			return str;
		}
		//fall through
	default:
		return defaultDescription;
	}
}

__declspec(naked) void GrenadeState(void)
{
	static int saved;
	__asm
	{
		mov edx, [0x49D660+ecx*4]
		pusha
		push edx
		call GetObjectDescription
		add esp,4
		mov saved,eax
		popa
		mov edx, saved
		ret
	}
}




static int draw_accuracy=0;
static int current_efficiency;
static int minimum_efficiency;
static int snap_penalty_distance;
static int auto_penalty_distance;
static int orange_cursor_limit;
static int red_cursor_limit;
void LoadAccuracyParameters()
{
	minimum_efficiency=INI_READ_INT("Range Based Accuracy","Minimum Efficiency",50);
	snap_penalty_distance=INI_READ_INT("Range Based Accuracy","Snap Penalty Distance",30);
	auto_penalty_distance=INI_READ_INT("Range Based Accuracy","Auto Penalty Distance",14);

	orange_cursor_limit=INI_READ_INT("Range Based Accuracy","Orange Cursor Threshold",95);
	red_cursor_limit=INI_READ_INT("Range Based Accuracy","Red Cursor Threshold",75);
}

int GetEfficiency(int xpos1,int ypos1,int xpos2,int ypos2)
{
	menu_item *mi=&WeaponMenu_Items[*WeaponMenu_ClickedItem];
	int distance=GetDistance(xpos1, ypos1, xpos2, ypos2);
	int efficiency=100;
	switch(mi->actionType)
	{
		case 1://autoshot: penalty starts at 14 (7 tiles)
			if(distance>auto_penalty_distance)
			{
				efficiency-=(distance-auto_penalty_distance);
			}
			break;
		case 2://snapshot: penalty starts at 30 (15 tiles)
			if(distance>snap_penalty_distance)
			{
				efficiency-=(distance-snap_penalty_distance);
			}
			break;
		case 3://aimedshot: no distance penalty
		default:
			break;
	}

	if(efficiency<minimum_efficiency)
		efficiency=minimum_efficiency;

	return efficiency;
}

void DrawPCKSpriteCursorHook(__int16 a, __int16 b, int c, int d)
{
	DrawPCKSprite(a,b,c,d);
//		62 -> green
//		32 -> red
//		16 -> orange
	current_efficiency=GetEfficiency(*currentUnit_xpos,*currentUnit_ypos,*tac_currentTile_xpos+*tac_xview,*tac_currentTile_ypos+*tac_yview);

	if(draw_accuracy)
	{
		char acc[64];
		int color=62;
		menu_item *mi=&WeaponMenu_Items[*WeaponMenu_ClickedItem];

		if(current_efficiency<orange_cursor_limit)
			color=16;
		if(current_efficiency<red_cursor_limit)
			color=32;

		int accuracy=((int)mi->accuracy*current_efficiency)/100;

//		sprintf(acc,"dist=%d eff=%d acc=%d%% cor=%d%%",distance,efficiency,(int)mi->accuracy,((int)mi->accuracy*efficiency)/100);
		sprintf(acc,"%d%%",accuracy);
		DrawString(acc,color,*mouse_ypos-16,*mouse_xpos-16,1);

		draw_accuracy=0;
	}
}

__declspec(naked) void DrawAccuracy(void)
{
	__asm
	{
		mov draw_accuracy,1
		mov dx, word ptr ds:[0x4783A8]
		ret
	}
}

void RangeBasedAccuracy()
{
	short x1=*(short *)0x4783F8;
	short y1=*(short *)0x4783FA;
	short x2=*(short *)0x478400;
	short y2=*(short *)0x478402;
	short saved_accuracy=*accuracy;

	if( x1 == x2 && y1 == y2 ) //vertical shot
		return;

	*accuracy=(*accuracy*current_efficiency)/100;

	AdjustShotWithAccuracy();

	*accuracy=saved_accuracy;
}
void ReactionFireAccuracy()
{
	int distance=GetDistance(*(short *)0x4783F8,*(short *)0x4783FA,*(short *)0x478400,*(short *)0x478402);
	int efficiency=100;

	//snapshot: penalty starts at 30 (15 tiles)
	if(distance>snap_penalty_distance)
	{
		efficiency-=(distance-snap_penalty_distance);
	}
	if(efficiency<minimum_efficiency)
		efficiency=minimum_efficiency;

	current_efficiency=efficiency;

	RangeBasedAccuracy();
}

void ForceLanguage()
{
#ifdef NDEBUG
	short lang=INI_READ_INT("Mod","Force Language",0);
#else
	short lang=1;
#endif
	if(lang>0 && lang<4)
	{
		*language=lang-1;
	}
	else
	{
		//select language
		((void (*)())(0x44C650))();
	}
}

void CreateInitialAlienBases()
{
	int nBases=INI_READ_INT("Mod","Initial Alien Bases",0);
	for(int i=0;i<nBases;i++)
	{
		unsigned char race=GetRandom_0_n(4);
		unsigned char zone=GetRandom_0_n(11);
		CreateAlienBase(zone,race);
	}
}

/*
 * Apply patches according to the ini file
 */
void ApplyPatches()
{
	InsertCall(0x44C6E9,ShowMod);
/*
	//force retaliation
	{
		char patch[]={0x90,0x90,0x90,0x90,0x90,0x90};
		PatchInPlace(0x432AD8,patch,6);
		PatchInPlace(0x432B06,patch,2);
		PatchInPlace(0x4594BD,patch,6);
	}
//*/

	//Stun
	if(INI_READ_INT("Mod","Stun Fest",0))
	{
		ModStun();
	}
	//Heavy laser MUST be after stun fest or combination won't work
	if(INI_READ_INT("Mod","Heavy Laser",0))
	{
		ModHeavyLaser();
	}


	//Activate stun for everyone
	if(0)
	{
//	0x41D9F4 75 63 
		Nop(0x41D9F4,2);
	}

	//shortcuts
	if(0)
	{
/*
.text:0045E0FF C7 05 20 86 47 00 01 00 00 00 mov     HasKeyBeenPressed, 1            ; jumptable 0045E059 case 254
.text:0045E109 33 C0                         xor     eax, eax
.text:0045E10B C2 10 00                      retn    10h
*/
		char switchtable[]={4};
		//reroute key messages to DefWindowProcA
		InsertJmp(0x45E0FF,(void *)0x45E1D5);
		InsertJmp(0x45E113,(void *)0x45E1D5);
		PatchInPlace(0x45E318,switchtable,1);

		//Hook DefWindowProcA
		Nop(0x45E1E5);
		InsertCall(0x45E1E6,MyDefWindowProcA);
		Nop(0x45E0EE);
		InsertCall(0x45E0EF,MyDefWindowProcA);

		//Shortcut handling
		InsertCall(0x42A82F,CheckShortcut);

		InsertJmp(0x45E540,GetPressedKey);
		InsertJmp(0x45E4E0,CheckKeyboardState);
	}

	//Create some bases from the begining
	if(INI_READ_INT("Mod","Initial Alien Bases",0))
	{
	//.text:0043B262 C3                            retn
		InsertJmp(0x43B262,CreateInitialAlienBases);
	}

	if(INI_READ_INT("Mod","Disable Base Defenses",0))
	{
		//.text:004578FC E8 8F 0A FF FF                call    ActivateBaseDefensesAgainstAlienShip
		char patch[]={0x33,0xC0}; //xor eax,eax
		PatchInPlace(0x4578FC,patch,2);
		Nop(0x4578FC+2,3);
	}

	if(INI_READ_INT("Mod","Surrender Defence Missions",0))
	{
//		.text:00457913 E8 A8 2D 00 00                call    AreThereSoldiersInBase
		char patch[]={0x33,0xC0}; //xor eax,eax
		PatchInPlace(0x457913,patch,2);
		Nop(0x457913+2,3);
	}

	if(INI_READ_INT("Mod","Funding Council Income Only",0))
	{
//		.text:00448E27 8B 4F 0A                      mov     ecx, [edi+0Ah]
		char patch[]={0x33, 0xC9, 0x90};
		PatchInPlace(0x448E27,patch,3);

//.text:004489B4 29 15 38 A8 49 00             sub     dword_49A838, edx
		Nop(0x4489B4,6);
//.text:00448931 03 C2                         add     eax, edx
		Nop(0x448931,2);
	}

	if(INI_READ_INT("Range Based Accuracy","Apply",0))
	{
		InsertCall(0x42669F,DrawAccuracy);
		Nop(0x42669F+5,2);

		InsertCall(0x4266D6,DrawPCKSpriteCursorHook);
		
		//aimed/snap shot
		InsertCall(0x40D369,RangeBasedAccuracy);

		//autoshot
		InsertCall(0x40EDFB,RangeBasedAccuracy);

		//reaction fire
		InsertCall(0x4105A4,ReactionFireAccuracy);

		LoadAccuracyParameters();
	}

	if(INI_READ_INT("Mod","More Smoke",0))
	{
		ModMoreSmoke();
	}

	//base maintenace estimate
	if(INI_READ_INT("Bug Fix","Displayed Base Maintenance Cost",0))
	{
		char patch[]={
			0x03, 0xc0,			// add eax,eax
			0x8a, 0x04, 0xc1,	// mov al, BYTE PTR [ecx+eax*8]
			0x0f, 0xb6, 0xc0,	// movzx	 eax, al
			0x90, 0x90, 0x90, 0x90, 0x90 //nops
		};
		PatchInPlace(0x440651,patch,13);
		Nop(0x44066E,3);
	}

	//Base build stacking
	if(INI_READ_INT("Mod","Base Building Stacking",0))
	{
		ModBaseBuildingStacking();
	}

	//Roswell mod. Scout ships can crash randomly
	if(INI_READ_INT("Roswell","Apply",0))
	{
		ModRoswell();
	}
	
	if(INI_READ_INT("Mod","Keep Base Navigation Modules",0))
	{
		Nop(0x415066,9);
	}

//crafts always ready
	if(INI_READ_INT("Mod","Crafts Always Ready",0))
	{
		//Check fuel level instead of state
		char patch[]={0x18,0x20,0x7c};
		PatchInPlace(0x45174E+4,patch,3);
	}

	if(INI_READ_INT("Mod","Stunned units KIA",0))
	{
		InsertCall(0x40CEB3,CheckDestroyObject);
	}

#ifdef NDEBUG
	if(INI_READ_INT("Bug Fix","Video Pitch",0))
#endif
	{
		InsertJmp(0x42FF10,FixPitch);
	}
	
	if(INI_READ_INT("Mod","No Blaster Bomb Drift",0))
	{
		Nop(0x426E78,5);
		Nop(0x40595F,5);
	}
	else if(INI_READ_INT("Bug Fix","Collectors Edition Blaster Bomb Bug",0))
	{
		InsertCall(0x426E78,FixedAccuracyCompensation);
		InsertCall(0x40595F,FixedAccuracyCompensation);
	}

	if(INI_READ_INT("Mod","More Reaction Fire",0))
	{
		InsertCall(0x42192B,ReactionFire1);
		InsertCall(0x421921,ReactionFire2);
	}

	if(INI_READ_INT("Mod","Manual Interception Fire Mode",0))
	{
		Nop(0x446B61,2);
		Nop(0x446AE8,6);

	//disable damage
	//	PatchInPlace(0x446E48,patch,4);
		
	}

#ifdef NDEBUG
	if(INI_READ_INT("Mod","Skip Intro",0))
#endif
	{
		Nop(0x45E69F,5);
	}

	if(INI_READ_INT("Equipment Screen","Show Stats",0)) 
	{
		//Revert old equipment screen patch in case the binary has already been hand patched
		char revert[]={ 0x5F, 0x5E, 0x5D, 0x5B, 0xC3 };
		//Patch coordinates of "TUs>" string
		char patchy[]={ 0x18+8 };
		char patchx[]={ 0xFA-5 };
		PatchInPlace(0x41947E,revert,5);
		PatchInPlace(0x418E9E,patchy,1);
		PatchInPlace(0x418E99,patchx,1);
		InsertJmp(0x419482,ShowEncumberance);
	}

	if(INI_READ_INT("Equipment Screen","Show Grenade State",0))
	{
		//.text:00418FEB 8B 14 8D 60 D6 49 00          mov     edx, StringsTable2_tactical[ecx*4]
		InsertCall(0x418FEB,GrenadeState);
		Nop(0x418FEB+5,2);
	}

#ifdef NDEBUG
	if(INI_READ_INT("Music","Apply",0)) 
#endif
	{
		ModMusic();
	}

	if(INI_READ_INT("Wreck Analysis","Apply",0))
	{
		InsertCall(0x4482B0,WreckAnalysis);
	}

/////////////////Bug Fixes/////////////////////

	//elerium ships
	if(INI_READ_INT("Bug Fix","Elerium-fueled Craft Bug",0))
	{
		InsertCall(0x4421AC,EleriumShipFix);
	}

	if(INI_READ_INT("Bug Fix","Transfered Crafts Refueled",0))
	{
//		044151F 66 C7 44 10 18 00 00    
		Nop(0x44151F,7);
	}

	if(INI_READ_INT("Bug Fix","Radar Stacking",0))
	{
		InsertJmp(0x439D10,FixRadarStacking);
	}

	if(INI_READ_INT("Bug Fix","Base Facility Dismantle-Construction Crash",0))
	{
		BaseFacilityDismantleConstructionCrash();
	}

#ifdef NDEBUG
	if(INI_READ_INT("Bug Fix","Tactical Scroll",0))
#endif
	{
		char patch_vsync[]={DDFLIP_WAIT};
		PatchInPlace(0x45C89D,patch_vsync,1); 
		InsertCall(0x4147D5,TimeFix);
		Nop(0x45C891,2); 
	}

	if(INI_READ_INT("Bug Fix","Proximity Grenades",0)) 
	{
		InsertCall(0x42A7D6,FixProximityMines);
	}

	if(INI_READ_INT("Bug Fix","Proximity Grenades Experience",0))
	{
		InsertCall(0x41E239,FixProximityMinesExperience);
	}

	if(INI_READ_INT("Bug Fix","Pay For Dirt",0)) 
	{
		char patch[]={0xff, 0xff, 0xff, 0xff};
		PatchInPlace(0x43BE4E,patch,4);
	}

	if(INI_READ_INT("Bug Fix","Phantom Radar",0)) 
	{
		char patch[]={0xeb, 0x43A2D2-0x43A290-5};
		PatchInPlace(0x43A290,patch,2);
		InsertJmp(0x43A2D5,PhantomRadarFix);
	}

	if(INI_READ_INT("Bug Fix","Base Disjoint",0))
	{
		InsertCall(0x41AFCA,BaseDisjointFix);
	}
/////////////////Enhancements///////////////////
	
#ifdef NDEBUG
	if(INI_READ_INT("Mod","Save Reserve Mode",0)) 
#endif
	{
		InsertCall(0x401014,SaveReserveMode);
		InsertCall(0x4012F6,RestoreReserveMode);
	}

	if(INI_READ_INT("Mod","Hot Grenades",0)) 
	{
		Nop(0x41E095,6);
	}

	if(INI_READ_INT("Mod","Alien Inventory",0)) 
	{
		Nop(0x412A20,8);
	}

	if(INI_READ_INT("Mod","Retaliate Against Ground Assault",0)) 
	{
		InsertCall(0x44720A,RetaliationAfterGroundAssault);
	}

	if(INI_READ_INT("Mod","Rank In Inventory",0)) 
	{
		InsertCall(0x41A581,DrawRank);
		InsertCall(0x418E8C,DrawRank);
//		Nop(0x41A43E,2);
	}

	InsertCall(0x44A11F,ForceLanguage);

//////////////////Hacks////////////////////
	
#ifdef NDEBUG
	if(INI_READ_INT("Hack","No Score Game Over",0)) 
#endif
	{
		HackNoScoreGameOver();
	}

	if(INI_READ_INT("Hack","No Alien Psi",0)) 
	{
		HackNoAlienPsi();
	}

	if(INI_READ_INT("Hack","Directly Use Alien Weapons",0)) 
	{
		HackDirectlyUseAlienWeapons();
	}

	if(INI_READ_INT("Hack","Recover All Clips",0))
	{
		 HackRecoverAllClips();
	}

	if(INI_READ_INT("Hack","Show All Locations",0))
	{
		HackShowAllLocations();
	}

	InsertJmp(0x425455,HackDebugFlagsCheck);
}
